
/*
 *  This file is part of "Ménapien !",
 *  a web-based self-learning applications framework.
 *
 *  Copyright (C) 2007-2008 Olivier Jacquemin.
 *
 *  "Ménapien !" is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  "Ménapien !" is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program: see the file COPYING.txt.  If not, see
 *  http://www.gnu.org/licenses/.
 */

/*extern QuestionsGenerator, Multiplication */

function MultiplicationsGenerator() {    
    this.parameters = { table: new NaturalParameter("table", "Table de :") };
}

MultiplicationsGenerator.prototype = new QuestionsGenerator();
MultiplicationsGenerator.prototype.constructor = MultiplicationsGenerator;


MultiplicationsGenerator.prototype.maxDifferentQuestions = 19;

function MultiplicationsGenerator_generateNewQuestion() {
    var table = null;
    var operandFirst = null;
    var randomOperand = null;
    var question = null;

    if (!this.allParametersSet()) {
        throw "Some parameters have not been set.";
    }

    table = this.parameters["table"].value;

    operandFirst = Math.round(Math.random());
    randomOperand = Math.floor(Math.random() * 11);
    if (operandFirst) {
        question = new Multiplication(randomOperand, table);
    }
    else {
        question = new Multiplication(table, randomOperand);            
    }
    return question;
}

MultiplicationsGenerator.prototype.generateNewQuestion = MultiplicationsGenerator_generateNewQuestion;

